#include <LPC2103.H>
#include <stdio.h>
#include <string.h> 
#include <stdarg.h>
#define CR     0x0D

unsigned char chr;
const unsigned char HDIGIT[16] = "0123456789ABCDEF";
unsigned char BCD[10];

void InitUART0(void)
{
	 PINSEL0 |= (1 << 4)|(1 << 6);
	 U0LCR = 0x83; 
	 U0DLL = 0x1A;  
	 U0DLM = 0x00;
	 U0LCR=0x03; 
}
//=====================================================================================
void BinToDec(unsigned long _value) {
unsigned long value;
	BCD[0]='0'; BCD[1]='0'; BCD[2]='0'; BCD[3]='0'; BCD[4]='0'; BCD[5]='0';  BCD[6]='0';  BCD[7]='0';
	value = _value;
	for(; value>=10000000;value-=10000000)	BCD[7]+=1;
	for(; value>=1000000;value-=1000000)	BCD[6]+=1;
	for(; value>=100000;value-=100000)		BCD[5]+=1;
	for(; value>=10000;value-=10000) 		BCD[4]+=1;
	for(; value>=1000;value-=1000)			BCD[3]+=1;
	for(; value>=100;value-=100)			BCD[2]+=1;
	for(; value>=10;value-=10) 				BCD[1]+=1;
	BCD[0]+=value;
}

//=====================================================================================

unsigned int putchar1(unsigned char  ch) 			  /* Write character to Serial Port    */
{                  		
  if (ch == '\n')  {
    while (!(U0LSR & 0x20));
    U0THR = CR;              	   /* output CR */
  }
  while (!(U0LSR & 0x20));
  return (U0THR = ch);
}
//=====================================================================================

void debug(unsigned char *ch,...)
{
unsigned char chr;
va_list arp;
va_start(arp, ch);

 while ((chr = *ch++)!=0){
if (chr != '%') {
 putchar1(chr);
 continue;
 }
 chr = *ch++;
  if (chr == '0'){ // param 2
    BinToDec(va_arg(arp, long));
	putchar1(BCD[7]);
	putchar1(BCD[6]);
	putchar1(BCD[5]);
	putchar1(BCD[4]);
	putchar1(BCD[3]);
	putchar1(BCD[2]);
	putchar1(BCD[1]);
	putchar1(BCD[0]);
	break;
  }
 }
}
//=====================================================================================

unsigned int getchar1(void) 				/* Read character from Serial Port   */
{                    
  while (!(U0LSR & 0x01)); 			
  return (U0RBR);
}
//***************************************************************************************

void get_line (char *buff, int len)
{
	char c;
	int idx = 0;

	for (;;) {
		c = getchar1();
		putchar1(c);
		if (c == 13) {buff[idx++] = 0; break;}
		if ((c == '\b') && idx) {
			idx--; putchar1(c);
		}
		if (((unsigned char)c >= ' ') && (idx < len - 1)) {
				buff[idx++] = c;
		}
	}
	buff[idx] = 0;
}
//====================================================================================

unsigned long StrToWord(char *buff)
{
 static unsigned long btt;
 char res;
 btt = 0;
 res = 1;
 do {
  btt *= 10;
  btt +=buff[res] -'0';
  res+=1;
  if (buff[res] == 0) break;
 }
 while (1);
 return btt;
}
//=====================================================================================
  
void dump_chr(unsigned char data)
{
  static unsigned char lbyte,hbyte;
  lbyte = data&0x0F;
  hbyte = data>>4; 
  putchar1(HDIGIT[hbyte]);
  putchar1(HDIGIT[lbyte]);
}
//=====================================================================================

//void put_dump(unsigned char data,unsigned int size)
//{
//	static int setbyte,cnt,tmp;
//	cnt = 0;
//	debug(" \n\000");
////	FAT_init();
//	for (setbyte=0;setbyte<size;setbyte++){
//	 dump_chr(SectorBuffer[setbyte]); 
//	 cnt++;
//	 if (cnt < 16) 
//	   debug("-\000");
//	 else { 
//	   debug("   \000");
//	 for (tmp = setbyte-16;tmp<setbyte;tmp++)
//	 if (SectorBuffer[tmp]>13)
//	   putchar1(SectorBuffer[tmp]);
//	 else
//	   putchar1('.');
//	   debug(" \n\000");
//	   cnt = 0;
//	 }
//   }
//}
//=====================================================================================


