
// =================================================     =====================================================
// =============================================================================
//           
// =============================================================================
#include <LPC23xx.h>
#include "debug.h"
#include "mci.h"


#define SD_CS_ON() 		(IOSET = (1 << 18))
#define SD_CS_OFF()		(IOCLR = (1 << 18))
#define LED_ON() 		(IOSET = (1 << 27))
#define LED_OFF()		(IOCLR = (1 << 27))

unsigned long MBR_sector_BIOS_PB; //  ()    ( 0) -  446 + 08h)

//***********************************************   BPB (BIOS Parameter Block) ************************************************
unsigned long BPB_SectSize; //     (  BIOS PB -  0Bh)[  512]
unsigned char BPB_ClustSize;//     (  BIOS PB -  ODh)
unsigned long BPB_ResSect;  //     FAT#1 (  BIOS PB -  0Eh)
unsigned char BPB_FatCnt;   // -  FAT   (  BIOS PB -  10h)[  2]
unsigned long BPB_RootSize; //  32-    (  BIOS PB -  11h)( FAT16   512)
unsigned long BPB_FatSize;  //     FAT (  BIOS PB -  16h)
//*************************************************************************************************************************************

//**********************************************   *******************************************************************
unsigned long FAT_begin; //  FAT (  )
unsigned long Root_dir_begin; //    (  )
unsigned long Data_begin; //    ( 2)  
//unsigned char SectorBuffer[512]; //    
unsigned long MMC_size;
unsigned long F_FileSize;

const char tbUniToASC[]={
197,96,96,170,96,178,175,96,96,96,
96,96,96,96,96,192,193,194,195,196,
197,198,199,200,201,202,203,204,205,206,
207,208,209,210,211,212,213,214,215,216,
217,218,219,220,221,222,223,224,225,226,
227,228,229,230,231,232,233,234,235,236,
237,238,239,240,241,242,243,244,245,246,
247,248,249,250,251,252,253,254,255,96,
96,96,96,186,73,179,191,};
// *************************************************************************************************************************************
//=====================================================================
//=====================================================================
char MMS_SPI(char lcd_data)
{ 
	S0SPDR = lcd_data;
//	while ((SSPSR & (1 << 0)) == 0){;}
	while ((S0SPSR & (1 << 7)) == 0){;}
//    delaySF_ms(0x01);
	return S0SPDR; 
}
//========================================================================

 char MMC_SendCommand(unsigned char cmd, unsigned long arg) 
{
        char r1,retry;
        retry=0;
        // 
        MMS_SPI(cmd|0x40);//
        MMS_SPI(arg>>24);//
        MMS_SPI(arg>>16);
        MMS_SPI(arg>>8);
        MMS_SPI(arg);  
        MMS_SPI(0x95);//      

        // ,     64 a,      0FF
        while((r1=MMS_SPI(0xff))==0xFF)if(retry++>64)break;
        //MMS_SPI(0xFF);
        // 
        return r1;
}
//===============================================================================

unsigned char MMC_Init(void) {
	
       unsigned char retry,r1;
        r1=retry=0;
		IODIR |= (1 << 18);			
        //    SPI
        do {
				SD_CS_ON();
                MMS_SPI(0xFF); 
                MMS_SPI(0xFF); 
                MMS_SPI(0xFF); 
                MMS_SPI(0xFF); 
                MMS_SPI(0xFF); 
                MMS_SPI(0xFF); 
                MMS_SPI(0xFF); 
                MMS_SPI(0xFF); 
                MMS_SPI(0xFF); 
                MMS_SPI(0xFF); 
				SD_CS_OFF();              
                r1=MMC_SendCommand(MMC_GO_IDLE_STATE, 0);
                retry++;
                if(retry>100)return 100;
        } while(r1!=0x01);  
        // 
        retry=0;
        do { 
                r1=MMC_SendCommand(MMC_SEND_OP_COND,0);
                retry++;
                if(retry>100)return r1;
        } while(r1);
     return r1;
	 
}
//=========================================================================

unsigned char MMC_ReadSector(unsigned long sector) {
        char r1;
        int i;
         SD_CS_OFF(); // 
         for(i=0;i<512;i++) { //   
                SectorBuffer[i]=0x00;
        } 
        LED_ON(); //  

        r1=MMC_SendCommand(MMC_READ_SINGLE_BLOCK, sector<<9);//  
        if(r1!=0)return r1;//      
        while(MMS_SPI(0xFF)!=MMC_STARTBLOCK_READ);//  

        for(i=0;i<512;i++) { //   
                SectorBuffer[i]=MMS_SPI(0xFF);
        } 

        // 2  CRC
      //  MMS_SPI(0xFF);
      //  MMS_SPI(0xFF);
	   while(MMS_SPI(0xFF)== 0);
        SD_CS_ON();// 
       // MMS_SPI(0xFF);
		 LED_OFF();
		 // put_dump(45,512);
        return 0;
} 


//=====================================================================
//=====================================================================



unsigned long  F_StartCluster, //    (  .. )
	F_ClusterBuf, //    ,       ( 0    )
	Current_sector,
	F_Size; //   


extern unsigned char y_lcd;
unsigned char record;
extern unsigned char  i;
extern unsigned char attrib;
//extern char 


void Send(const char *Buff, unsigned char cnt) //    FLASH
{
		memcpy(SectorBuffer, Buff, 512);
}

unsigned char FAT_init(void) 
{
        unsigned char result;


//        //   ()  (MBR - Master Boot Record)
    if ( MCI_Read_Block( i ) != TRUE )
	{
	  debug("Error MCI_Read_Block!\n");		/* Fatal error */
	  return result;
	}
      
//        
        if (SectorBuffer[510] != 0x55 || SectorBuffer[511] != 0xAA)
         {
         debug("Card not formated!\n");
         }      
//         

//		Send(Image22,12);

        BPB_SectSize = ReadBlock[0x0c];  //     (  BIOS PB)[  512]
        BPB_SectSize <<=8;  
        BPB_SectSize += ReadBlock[0x0b]; //
        //lcdPrintText("Sector size", 2,20, BLACK);
        //lcd_out_dec(120,20,BPB_SectSize,BLACK); // :    MBR
        
        BPB_ClustSize = ReadBlock[0x0D]; //     (  BIOS PB)
        //lcdPrintText("Cluster size", 2,36, BLACK);
        //lcd_out_dec(120,36,BPB_ClustSize,BLACK);
        
        BPB_ResSect = ReadBlock[ 0x0f];  //     FAT#1 (  BIOS PB) 
        BPB_ResSect <<=8;                   //
        BPB_ResSect += ReadBlock[ 0x0e]; //

        //lcdPrintText("Reserv sector", 2,52, BLACK);
        //lcd_out_dec(120,52,BPB_ResSect,BLACK);
       
        BPB_FatCnt = ReadBlock[0x10];    // -  FAT   (  BIOS PB)[  2]

        BPB_RootSize = ReadBlock[0x12];  //  32-    ( FAT16   512)
        BPB_RootSize <<=8;                  //                                                  ( FAT32   0)
        BPB_RootSize += ReadBlock[0x11]; //

        BPB_FatSize = ReadBlock[0x17];   //     FAT (  BIOS PB)
        BPB_FatSize  <<=8;                  //
        BPB_FatSize  += ReadBlock[0x16]; //
        
        //lcdPrintText("Fat Size", 2,68, BLACK);
        //lcd_out_dec(120,68,BPB_FatSize,BLACK);
        //     
        MMC_size = ReadBlock[0x23];
        MMC_size <<=8;
        MMC_size+= ReadBlock[0x22];
        MMC_size <<=8;
        MMC_size+= ReadBlock[0x21];
        MMC_size <<=8;
        MMC_size+= ReadBlock[0x20];
        MMC_size = MMC_size*512;
        MMC_size=MMC_size/1000000;
     	MBR_sector_BIOS_PB = 0;
       //   
        FAT_begin = MBR_sector_BIOS_PB + BPB_ResSect; //  FAT
        Root_dir_begin = FAT_begin + (BPB_FatSize * BPB_FatCnt); //   
        Data_begin = Root_dir_begin + (BPB_RootSize * 32 / 512); //    ( 2)
        return 0;
}


//===============================================================================================
//        FAT
//  :    
// ==============================================================================================
unsigned long  NextCluster(unsigned long cluster) 
{ 
        unsigned long tmp1, tmp2, tmp3, tmp4, tmp5;
        tmp1 = cluster / 256;    //    FAT (  FAT)
        tmp2 = FAT_begin + tmp1; //    
        tmp3 = cluster % 256;    //      (..  )
        tmp4 = 2 * tmp3;         //    
        MMC_ReadSector(tmp2);       
        tmp5 = SectorBuffer[tmp4+1]; //   
        tmp5 <<=8;                   //
        tmp5 += SectorBuffer[tmp4];  //
        F_ClusterBuf=0; //  0 ..        
        return tmp5; //    ()
}


////===========================
//unsigned char Readfirstsector(unsigned long cluster) 
//{
//        unsigned char result; 
//        Current_sector= (Data_begin+(cluster-2)*BPB_ClustSize);       //    ,    
//        return result;                                                              // BPB_ClustSize .
//}                                                                      //         
//                                                                      //      
//       
//unsigned long Get_file_size(void)
//        {
//    F_Size = SectorBuffer[(record*32)+0x1F];
//    F_Size <<= 8;
//    F_Size += SectorBuffer[(record*32)+0x1E];
//    F_Size <<= 8;
//    F_Size += SectorBuffer[(record*32)+0x1D];
//    F_Size <<= 8;
//    F_Size += SectorBuffer[(record*32)+0x1C]; 
//    return F_Size;
//        }
//
// unsigned long Get_Start_Cluster(void)
// {
//	F_StartCluster = SectorBuffer[(record*32)+0x15];     //    **   32
//	F_StartCluster <<= 8;
//	F_StartCluster += SectorBuffer[(record*32)+0x14];   //     **   32
//	F_StartCluster <<= 8;
//	F_StartCluster = SectorBuffer[(record*32)+0x1B];   //   
//	F_StartCluster <<= 8;
//	F_StartCluster += SectorBuffer[(record*32)+0x1A];  //   
//	        return F_StartCluster;
//}


char UniToASC(unsigned char data1,unsigned char data2)
{
    int chr;
//	unsigned char res1;
	if (data2 == 0) return(data1);
	else{
	  chr = data2<<8;
	  chr+=data1;
	  	chr -= 1025;
		if (chr < 86)
		return (tbUniToASC[chr]);
	}
  return (data1);
}
// ======================================================================================

void FindFiles(void)
{
char F_LName[64];
char attrib,i,setL;
int root_sector;
static unsigned char setLL;

for (root_sector = Root_dir_begin; root_sector <= (Root_dir_begin+32);root_sector++){
	MMC_ReadSector(root_sector);
    record =0;
	setLL = 0;
    while(SectorBuffer[record*32] !=0){
	if (SectorBuffer[record*32] != 0xe5) { //    -   ,  
	  attrib = SectorBuffer[(record*32)+11]; //  
	  if (attrib == 0x20 || attrib == 0x10 ){
	    F_StartCluster = SectorBuffer[(record*32)+27]<<8;
	    F_StartCluster += SectorBuffer[(record*32)+26];
		F_FileSize =  SectorBuffer[(record*32)+30]<<16;
		F_FileSize +=  SectorBuffer[(record*32)+29]<<8;
		F_FileSize += SectorBuffer[(record*32)+28];
		}
	   else if (attrib == 0x0F) {
		 setL = SectorBuffer[(record*32)];
		 setL &= 0x3f; 
		 if (setL > 0) setL--;
			 setL*=13;
			 F_LName[setL]    = UniToASC(SectorBuffer[(record*32)+1],SectorBuffer[(record*32)+2]);
			 F_LName[setL+1]  = UniToASC(SectorBuffer[(record*32)+3],SectorBuffer[(record*32)+4]);
			 F_LName[setL+2]  = UniToASC(SectorBuffer[(record*32)+5],SectorBuffer[(record*32)+6]);
			 F_LName[setL+3]  = UniToASC(SectorBuffer[(record*32)+7],SectorBuffer[(record*32)+8]);
			 F_LName[setL+4]  = UniToASC(SectorBuffer[(record*32)+9],SectorBuffer[(record*32)+10]);
			 F_LName[setL+5]  = UniToASC(SectorBuffer[(record*32)+14],SectorBuffer[(record*32)+15]);
			 F_LName[setL+6]  = UniToASC(SectorBuffer[(record*32)+16],SectorBuffer[(record*32)+17]);
			 F_LName[setL+7]  = UniToASC(SectorBuffer[(record*32)+18],SectorBuffer[(record*32)+19]);
			 F_LName[setL+8]  = UniToASC(SectorBuffer[(record*32)+20],SectorBuffer[(record*32)+21]);
			 F_LName[setL+9]  = UniToASC(SectorBuffer[(record*32)+22],SectorBuffer[(record*32)+23]);
			 F_LName[setL+10] = UniToASC(SectorBuffer[(record*32)+24],SectorBuffer[(record*32)+25]);
			 F_LName[setL+11] = UniToASC(SectorBuffer[(record*32)+28],SectorBuffer[(record*32)+29]);
			 F_LName[setL+12] = UniToASC(SectorBuffer[(record*32)+30],SectorBuffer[(record*32)+31]);
			 setLL += 13;
			 if (setL == 0){
			 debug(" \n\000");
			 for (i=0;i<setLL;i++){
			 if ((F_LName[i]==0xFF))  break; 
			 putchar1(F_LName[i]);
			 }
		 setLL = 0;
		 }
	   }
	}
	record++;
  }
 }
}
//======================================================================================================



        
  
